/* 
  This file arranges for the display of the function in the plane 
  in which the dogleg will be chosen.  This is not complete.
 */
#include <math.h>
#include "tools.h"
#include "nonlin/nlall.h"
#include "nonlin/min2/dogleg.h"

static double *fx;
static void   (*ff)();
static void   *Nc, *Uc;

/* Return the 2-norm of the function */
static double MyFcn( n, x )
int    n;
double *x;
{
int    i;
double sum;
(*ff)( Nc, Uc, x, fx );
sum = 0;
for (i=0; i<n; i++) sum += fx[i] * fx[i];
return sqrt( sum );
}

/*ARGSUSED*/
void NLDogLegMonitor( nlP, usrP, delta, x, f, fnorm, p )
NLCntx *nlP;
int    *usrP;
double *x, *f, fnorm, delta, *p;
{
int    n, nx, ny;
double rx, ry;
double *s, *w1;
NLStepDogleg *Sctx;

Sctx = (NLStepDogleg *)nlP->stepCtx;
s    = (double *)(Sctx->work[0]);
w1   = (double *)(Sctx->work[2]);

Nc = (void *)nlP;
Uc = (void *)usrP;
nx = 21;
ny = 21;
rx = ry = delta;
n  = *usrP;
ff = nlP->fun;
fx = (double *)MALLOC( n * sizeof(double) );
XBFunContour( n, x, w1, s, nx, ny, rx, ry, MyFcn, 32 );

/* Eventually, we want to draw the dogleg */
XBQSetColor( "black" );
XBFunDrawLine( n, x, w1, s, rx, ry, s );
XBQSetColor( "white" );
XBFunDrawLine( n, x, w1, s, rx, ry, p );

FREE( fx );
getc(stdin);
}

