
#ifndef __AXIS
#define __AXIS

typedef struct {
    double xlow, ylow, xhigh, yhigh;   /* User - coord limits */
    int    x, y, w, h;                 /* drawing area */
    int    xa, ya, wa, ha;             /* axis area */
    char   *(*ylabelstr)(),            /* routines to generate labels */ 
           *(*xlabelstr)();
    void   (*xlabels)(), (*ylabels)(), /* location of labels */
           (*xticks)(),  (*yticks)();  /* location and size of ticks */
    XBWindow *win;
    XBFont   *font;
    } XBAxisData;

extern XBAxisData *XBAInitAxis();
extern void XBADefTicks();
extern char *XBADefLabel();
#endif
